<?php
class LyricWiki {
	private $apiUrl = 'http://lyrics.wikia.com/api.php';

	public function __construct() {
	}

	public function getLyricsList($artist, $title, $info) {
		$count = 0;

		$searchUrl = sprintf(
			"%s?artist=%s&song=%s&fmt=realjson",
			$this->apiUrl, urlencode($artist), urlencode($title)
		);

		$content = $this->getContent($searchUrl);

		$obj = json_decode($content, TRUE);

		if ($obj['lyrics'] !== 'Not found') {
			$obj = $this->decodeUTF8($obj);
			$id = $obj['lyrics'];
			$info->addTrackInfoToList($obj['artist'], $obj['song'], $id, $obj['lyrics']);

			$count = 1;
		}

		return $count;
	}

	public function getLyrics($id, $info) {
		$info->addLyrics($id, $id);

		return true;
	}

	private function getContent($url) {
		$curl = curl_init();

		curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 30);
		curl_setopt($curl, CURLOPT_TIMEOUT, 30);
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, TRUE);
		curl_setopt($curl, CURLOPT_VERBOSE, TRUE);
		curl_setopt($curl, CURLOPT_URL, $url);

		$result = curl_exec($curl);
		curl_close($curl);

		return $result;
	}

	private function getFirstMatch($string, $pattern) {
		if (1 === preg_match($pattern, $string, $matches)) {
			return $matches[1];
		}

		return FALSE;
	}

	private function decodeUTF8($obj) {
		$tryDecodeFunc = function($str) {
			if ($str) {
				$length = strlen($str);
				$temp = '';

				// if decode failed, remove character from end and decode again
				while (empty($temp) && $length > 0) {
					$temp = utf8_decode(substr($str, 0, $length));

					$jsonStr = json_encode($temp);
					if (empty($jsonStr) || 'null' === $jsonStr) {
						// will lead to json_encode() fail
						$temp = '';
					}
					$length -= 1;
				}

				$str = $temp;
			}

			return $str;
		};

		return array_map($tryDecodeFunc, $obj);
	}
}
?>

