#!/bin/sh
# Copyright (c) 2000-2012 Synology Inc. All rights reserved.

if [ -z "$SYNOPKG_PKGNAME" ]; then
	PACKAGE_NAME="AudioStation"
else
	PACKAGE_NAME=$SYNOPKG_PKGNAME
fi

AUDIO_PACKAGE_FOLDER="/var/packages/${PACKAGE_NAME}"

PSQL="/usr/syno/pgsql/bin/psql"
DATABASE="mediaserver"
SQL="${AUDIO_PACKAGE_FOLDER}/target/scripts/upgrade/002_add_updated_column.pgsql"

ExecSqlCommand()
{
	$PSQL -U admin $DATABASE -c "$1" > /dev/null 2>&1
}

echo "Test whether personal library tables exist or not"
ExecSqlCommand "SELECT 1 FROM personal_music LIMIT 1;"
if [ $? = 1 ]; then
	echo "No personal library tables, return"
	return 0
fi

echo "Test updated column in personal library tables"
ExecSqlCommand "SELECT updated FROM personal_music LIMIT 1;"
if [ $? = 1 ]; then
	echo "Add updated columns in personal library tables"
	$PSQL -U admin $DATABASE < $SQL
	if [ $? != 0 ]; then
		echo "Failed to create updated column in personal library tables"
		exit
	fi
fi

exit 0;
